# Supplementary Material for C-Space Tunnel Discovery for Puzzle Path Planning

## hand_picked_key_configurations/

This directory contains some samples of predicated key configurations.
We picked some good predications from all predicated key configurations, to
provided some intuition what key configurations may be generated in our
pipeline.

## training_image_samples/

This directory includes the 100 mini-batches of training images for the three networks.
For each file, the first four digits indicates the index of mini-batch,
and second number indicates the index inside each mini-batch.
The last word shows the channel(s) the image stored.
The rendered ground truth is stored as `-psi.png` files.

## puzzles/

This directory includes all puzzles used in our paper, and a blender-based visualizer.
Each subdirectory contains one or more `.cfg` file, which is the OMPL problem
definition file.
The (discrete) collision resolution is also stored inside the file.

Our models are stored as OBJ file format. All of them have been remeshed with
TetWild, and added zero distortion UV coordinates to track feature density
function psi.

The solution files are stored as `.npz` files. They can be used in conjunction
with the configuration file to visualize the solution path in blender

For OMPL users, we store also store the solution path as `.ompl.txt` format,
which is readable by OMPL GUI application.

## Use puzzles/path_visualizer.py to visualize the solution path in blender

The usage of this script is straightforward
```
	./path_visualizer.py <.cfg file> <.npz file>
```

By default this visualizer reads the simplified path solution.
However BE AWARE the path simplification code from OMPL may return incorrect path.
Pass `--use_original_path` to this script to visualize the unsimplified path.

The `core_bpy_script.py` in the same directory is the blender python script
which implements the loading of the puzzle and path. This script requires
scipy to run. (Note blender may ship its own python and the scipy must also be
installed there).
